/*
 * etrace.h - Accessors and constants for etchtrace files.
 *            This file is not publically available, since it
 *            contains code from etchtrace.h, which is
 *            only available by licence from UW. To be fixed...
 *
 */

#ifndef ETRACE_H
#define ETRACE_H


#define ET_TYPE(keybyte)	(keybyte&0xf0)
#define ET_LENGTH(keybyte)	(keybyte&0x0f)
#define GET_DESC(keybyte)    (keybyte&0x0f)
#define ET_ENTRY(etype,desc) (etype | desc)

enum TYPES { ET_MODULE  = 0xD0,
	     ET_INST	= 0x10,
	     ET_LOAD	= 0x20,
	     ET_STORE	= 0x30,
	     ET_INSTNEXT= 0x50,
	     ET_LOADNEXT= 0x60,
	     ET_STORENEXT=0x70,
	     ET_EOF	= 0x80,
	     ET_BRANCH  = 0x90,
	     ET_THREAD  = 0xA0,
	     ET_PROC    = 0xB0 };


/* module types */
enum MTYPES  { MT_LOAD,    /* followed by byte - MID */
	       MT_UNLOAD,  /* followed by byte - MID */ 
	       MT_SWITCH,  /* switch to a module - followed by a byte MID,
			      followed by its name */
	       //   MT_NAME,    /* name of a module - followed by a null */ 
	                   /*    delimited string */
	       MT_MAX_TYPES };


#endif /* ETRACE_H */
