/*
 * input.h - API for reading from trace files.
 *
 */

#ifndef INPUT_H
#define INPUT_H

/* Open the given file for input. If zlib is available, the file may
 * be compressed. If file is NULL, stdin will be read (again, may be compressed
 * if zlib available). */
void input_init(char *file);

/* Read the next address from the file. The length of the reference, since
 * x86 may have longer than 1-word references, is returned in length.
 * Returns TRUE if got a reference, FALSE on EOF.
 */
bool_t input_next_ref(vaddr_t *addr, ref_kind_t *type, uint *length);

void input_get_stats(int *curr, int *len);

#endif /* INPUT_H */
